# Angular Grid

Angular Grid component for Enterprise Apps. jQWidgets Grid for Angular 6 is a professional datagrid component built with Typescript, Angular and the jQWidgets framework. It offers hundreds of features like sorting, filtering, grouping, master-detail views, paging and more. It also ships with many advanced capabilities like drag and drop, columns resize, printing, data export, aggregates, RTL support and more. The Angular data grid is a perfect solution for enterprise applications built with the Angular 6 UI framework. It supports native Angular features like AOT compilation, declarative configuration, TypeScript compile-time checking and more.

![Angular Grid](https://www.jqwidgets.com/angular/images/angular-grid-component.png)

# Sorting

Angular 6 applications using the data grid component can benefit from advanced filtering (including custom filters), and sorting capabilities. The grid sorting is customizable and can be enabled or disabled. The data in the grid can be sorted from the UI by clicking on a column or using a context menu button, as well as programmatically via the APIs of the Angular grid. The default behavior of the sorting function is to apply ascending or descending sort depending values in each column. The grid's API also allow developers to extend and customize the sorting with custom sort and compare functions.

# Filtering

The filtering in the Angular data grid component is extremely flexible. The grid offers standard filters with context menus and selection of filtering operators and conditions. The developer may also choose to use a filter row which will appear at the top of the grid's rows. Users may enter data in each column and the filtration will be done by matching the corresponding records in the grid. The filter menus are fully customizable. The Angular grid also provides Excel-style filters with checkbox selection of the items in each grid column. Filtering can be achieved through API as well. 

# Grouping

The data in the Data Grid can be grouped and also you can turn on Group Aggregates. You can group by using the Grid Column's Menu or through its API and especially the groups property. 

# Editing

Our component supports multiple edit modes. Users can edit by cell, by row or through a popup. Edit validation is built-in as well. Some of the editors which can be used are TextBox, DateTimePicker, NumberInput, ComboBox, DropDownList, CheckBox. 

Editing can be validated by using custom validation functions. Developers may also add custom editors and customize the editing process through the API.

# Angular Material Design

By using our Grid component, users can apply Material Design very easily. With the release of Angular 6 and jQWidgets ver. 6.0.6, the usage of Angular Material design has become easier as well. You can use the Material Design styled Grid by setting its "theme" property to one of the available material themes - material, material-purple and material-green.

# Advanced Features

For the Angular applications requiring complex features, our DataGrid offers drag and drop (including dragging multiple rows), row details, custom keyboard navigation, deferred scrolling on large data sets, nested grids, master-details grids, toolbars on the grid, status bar, right to left support and more.

# Export and printing

The Data Grid UI component offers export to Excel, PDF, XML, HTML, CSV, TSV and JSON. It also offers data printing.
